/************
Virtu@L Dream, DreamCast emulator for PC
Copyright (C) 2003 eBrain  H.H.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
************/

#include "StdAfx.h"
#include "extern.h"
#define SH4DSM

#ifdef SH4DSM
char dsmmsg[80];

 #define ADD_DSMINFO sprintf(dsmmsg,"ADD R%d,R%d",m,n);
 #define ADDI_DSMINFO sprintf(dsmmsg,"ADD #%d,R%d",i,n);
 #define ADDC_DSMINFO sprintf(dsmmsg,"ADDC R%d,R%d",m,n);
 #define ADDV_DSMINFO sprintf(dsmmsg,"ADDV R%d,R%d",m,n);
 #define AND_DSMINFO sprintf(dsmmsg,"AND R%d,R%d",m,n);
 #define ANDI_DSMINFO sprintf(dsmmsg,"AND #%d,R0",i);
 #define ANDM_DSMINFO sprintf(dsmmsg,"AND.B #%d,@(R0,GBR)",i);
 #define BF_DSMINFO sprintf(dsmmsg,"BF %d",disp);
 #define BFS_DSMINFO sprintf(dsmmsg,"BFS %d",disp);
 #define BRA_DSMINFO sprintf(dsmmsg,"BRA %d",disp);
 #define BRAF_DSMINFO sprintf(dsmmsg,"BRAF R%d",n);
 #define BSR_DSMINFO sprintf(dsmmsg,"BSR %d",disp);
 #define BSRF_DSMINFO sprintf(dsmmsg,"BSRF R%d",n);
 #define BT_DSMINFO sprintf(dsmmsg,"BT %d",disp);
 #define BTS_DSMINFO sprintf(dsmmsg,"BTS %d",disp);
 #define CLRMAC_DSMINFO sprintf(dsmmsg,"CLRMAC");
 #define CLRS_DSMINFO sprintf(dsmmsg,"CLRS");
 #define CLRT_DSMINFO sprintf(dsmmsg,"CLRT");
 #define CMPEQ_DSMINFO sprintf(dsmmsg,"CMP_EQ R%d,R%d",m,n);
 #define CMPGE_DSMINFO sprintf(dsmmsg,"CMP_GE R%d,R%d",m,n);
 #define CMPGT_DSMINFO sprintf(dsmmsg,"CMP_GT R%d,R%d",m,n);
 #define CMPHI_DSMINFO sprintf(dsmmsg,"CMP_HI R%d,R%d",m,n);
 #define CMPHS_DSMINFO sprintf(dsmmsg,"CMP_HS R%d,R%d",m,n);
 #define CMPPL_DSMINFO sprintf(dsmmsg,"CMP_PL R%d",n);
 #define CMPPZ_DSMINFO sprintf(dsmmsg,"CMP_PZ R%d",n);
 #define CMPSTR_DSMINFO sprintf(dsmmsg,"CMP_STR R%d,R%d",m,n);
 #define CMPIM_DSMINFO sprintf(dsmmsg,"CMP_EQ #%d,R0",i);
 #define DIV0S_DSMINFO sprintf(dsmmsg,"DIV0S R%d,R%d",m,n);
 #define DIV0U_DSMINFO sprintf(dsmmsg,"DIV0U");
 #define DIV1_DSMINFO sprintf(dsmmsg,"DIV1 R%d,R%d",m,n);
 #define DMULS_DSMINFO sprintf(dsmmsg,"DMULS.L R%d,R%d",m,n);
 #define DMULU_DSMINFO sprintf(dsmmsg,"DMULU.L R%d,R%d",m,n);
 #define DT_DSMINFO sprintf(dsmmsg,"DT R%d",n);
 #define EXTSB_DSMINFO sprintf(dsmmsg,"EXTS.B R%d,R%d",m,n);
 #define EXTSW_DSMINFO sprintf(dsmmsg,"EXTS.W R%d,R%d",m,n);
 #define EXTUB_DSMINFO sprintf(dsmmsg,"EXTU.B R%d,R%d",m,n);
 #define EXTUW_DSMINFO sprintf(dsmmsg,"EXTU.W R%d,R%d",m,n);
 #define JMP_DSMINFO sprintf(dsmmsg,"JMP @R%d",n);
 #define JSR_DSMINFO sprintf(dsmmsg,"JSR @R%d",n);
 #define LDCSR_DSMINFO sprintf(dsmmsg,"LDC R%d,SR (P)",m);
 #define LDCGBR_DSMINFO sprintf(dsmmsg,"LDC R%d,GBR",m);
 #define LDCVBR_DSMINFO sprintf(dsmmsg,"LDC R%d,VBR (P)",m);
 #define LDCSSR_DSMINFO sprintf(dsmmsg,"LDC R%d,SSR (P)",m);
 #define LDCSPC_DSMINFO sprintf(dsmmsg,"LDC R%d,SPC (P)",m);
 #define LDCDBR_DSMINFO sprintf(dsmmsg,"LDC R%d,DBR (P)",m);
 #define LDCRn_BANK_DSMINFO sprintf(dsmmsg,"LDC R%d,R%d_BANK (P)",m,n);
 #define LDCMSR_DSMINFO sprintf(dsmmsg,"LDC.L @R%d+,SR (P)",m);
 #define LDCMGBR_DSMINFO sprintf(dsmmsg,"LDC.L @R%d+,GBR",m);
 #define LDCMVBR_DSMINFO sprintf(dsmmsg,"LDC.L @R%d+,VBR (P)",m);
 #define LDCMSSR_DSMINFO sprintf(dsmmsg,"LDC.L @R%d+,SSR (P)",m);
 #define LDCMSPC_DSMINFO sprintf(dsmmsg,"LDC.L @R%d+,SPC (P)",m);
 #define LDCMDBR_DSMINFO sprintf(dsmmsg,"LDC.L @R%d+,DBR (P)",m);
 #define LDCMRn_BANK_DSMINFO sprintf(dsmmsg,"LDC.L @R%d+,R%d_BANK (P)",m,n);
 #define LDSFPUL_DSMINFO sprintf(dsmmsg,"LDS R%d,FPUL",m);
 #define LDSMFPUL_DSMINFO sprintf(dsmmsg,"LDS.L @R%d+,FPUL",m);
 #define LDSFPSCR_DSMINFO sprintf(dsmmsg," LDS R%d,FPSCR",m);
 #define LDSMFPSCR_DSMINFO sprintf(dsmmsg," LDS.L @R%d+,FPSCR",m);
 #define LDSMACH_DSMINFO sprintf(dsmmsg,"LDS R%d,MACH",m);
 #define LDSMACL_DSMINFO sprintf(dsmmsg,"LDS R%d,MACL",m);
 #define LDSPR_DSMINFO sprintf(dsmmsg,"LDS R%d,PR",m);
 #define LDSMMACH_DSMINFO sprintf(dsmmsg,"LDS.L @R%d+,MACH",m);
 #define LDSMMACL_DSMINFO sprintf(dsmmsg,"LDS.L @R%d+,MACL",m);
 #define LDSMPR_DSMINFO sprintf(dsmmsg,"LDS.L @R%d+,PR",m);
 #define LDTLB_DSMINFO sprintf(dsmmsg,"LDTLB");
 #define MAC_L_DSMINFO sprintf(dsmmsg,"MAC.L @R%d+,@R%d+",m,n);
 #define MACW_DSMINFO sprintf(dsmmsg,"MAC.W @R%d+,@R%d+",m,n);
 #define MOV_DSMINFO sprintf(dsmmsg,"MOV R%d,R%d",m,n);
 #define MOVBS_DSMINFO sprintf(dsmmsg,"MOV.B R%d,@R%d",m,n);
 #define MOVWS_DSMINFO sprintf(dsmmsg,"MOV.W R%d,@R%d",m,n);
 #define MOVLS_DSMINFO sprintf(dsmmsg,"MOV.L R%d,@R%d",m,n);
 #define MOVBL_DSMINFO sprintf(dsmmsg,"MOV.B @R%d,R%d",m,n);
 #define MOVWL_DSMINFO sprintf(dsmmsg,"MOV.W @R%d,R%d",m,n);
 #define MOVLL_DSMINFO sprintf(dsmmsg,"MOV.L @R%d,R%d",m,n);
 #define MOVBM_DSMINFO sprintf(dsmmsg,"MOV.B R%d,@-R%d",m,n);
 #define MOVWM_DSMINFO sprintf(dsmmsg,"MOV.W R%d,@-R%d",m,n);
 #define MOVLM_DSMINFO sprintf(dsmmsg,"MOV.L R%d,@-R%d",m,n);
 #define MOVBP_DSMINFO sprintf(dsmmsg,"MOV.B @R%d+,R%d",m,n);
 #define MOVWP_DSMINFO sprintf(dsmmsg,"MOV.W @R%d+,R%d",m,n);
 #define MOVLP_DSMINFO sprintf(dsmmsg,"MOV.L @R%d+,R%d",m,n);
 #define MOVBS0_DSMINFO sprintf(dsmmsg,"MOV.B R%d,@(R0,R%d)",m,n);
 #define MOVWS0_DSMINFO sprintf(dsmmsg,"MOV.W R%d,@(R0,R%d)",m,n);
 #define MOVLS0_DSMINFO sprintf(dsmmsg,"MOV.L R%d,@(R0,R%d)",m,n);
 #define MOVBL0_DSMINFO sprintf(dsmmsg,"MOV.B @(R0,R%d),R%d",m,n);
 #define MOVWL0_DSMINFO sprintf(dsmmsg,"MOV.W @(R0,R%d),R%d",m,n);
 #define MOVLL0_DSMINFO sprintf(dsmmsg,"MOV.L @(R0,R%d),R%d",m,n);
 #define MOVI_DSMINFO sprintf(dsmmsg,"MOV #%d,R%d",i,n);
 #define MOVWI_DSMINFO sprintf(dsmmsg,"MOV.W @(%d,PC),R%d",d,n);
 #define MOVLI_DSMINFO sprintf(dsmmsg,"MOV.L @(%d,PC),R%d",d,n);
 #define MOVBLG_DSMINFO sprintf(dsmmsg,"MOV.B @(%d,GBR),R0",d);
 #define MOVWLG_DSMINFO sprintf(dsmmsg,"MOV.W @(%d,GBR),R0",d);
 #define MOVLLG_DSMINFO sprintf(dsmmsg,"MOV.L @(%d,GBR),R0",d);
 #define MOVBSG_DSMINFO sprintf(dsmmsg,"MOV.B R0,@(%d,GBR)",d);
 #define MOVWSG_DSMINFO sprintf(dsmmsg,"MOV.W R0,@(%d,GBR)",d);
 #define MOVLSG_DSMINFO sprintf(dsmmsg,"MOV.L R0,@(%d,GBR)",d);
 #define MOVBS4_DSMINFO sprintf(dsmmsg,"MOV.B R0,@(%d,R%d)",d,n);
 #define MOVWS4_DSMINFO sprintf(dsmmsg,"MOV.W R0,@(%d,R%d)",d,n);
 #define MOVLS4_DSMINFO sprintf(dsmmsg,"MOV.L R%d,@(%d,R%d)",m,d,n);
 #define MOVBL4_DSMINFO sprintf(dsmmsg,"MOV.B @(%d,R%d),R0",d,m);
 #define MOVWL4_DSMINFO sprintf(dsmmsg,"MOV.W @(%d,R%d),R0",d,m);
 #define MOVLL4_DSMINFO sprintf(dsmmsg,"MOV.L @(%d,R%d),R%d",d,m,n);
 #define MOVA_DSMINFO sprintf(dsmmsg,"MOVA @(%d,PC),R0",d);
 #define MOVCAL_DSMINFO sprintf(dsmmsg,"MOVCA.L R0,@R%d",n);
 #define MOVT_DSMINFO sprintf(dsmmsg,"MOVT R%d",n);
 #define MULL_DSMINFO sprintf(dsmmsg,"MUL.L R%d,R%d",m,n);
 #define MULS_DSMINFO sprintf(dsmmsg,"MULS R%d,R%d",m,n);
 #define MULU_DSMINFO sprintf(dsmmsg,"MULU R%d,R%d",m,n);
 #define NEG_DSMINFO sprintf(dsmmsg,"NEG R%d,R%d",m,n);
 #define NEGC_DSMINFO sprintf(dsmmsg,"NEGC R%d,R%d",m,n);
 #define NOP_DSMINFO sprintf(dsmmsg,"NOP");
 #define NOT_DSMINFO sprintf(dsmmsg,"NOT R%d,R%d",m,n);
 #define OCBI_DSMINFO sprintf(dsmmsg,"OCBI @R%d",n);
 #define OCBP_DSMINFO sprintf(dsmmsg,"OCBP @R%d",n);
 #define OCBWB_DSMINFO sprintf(dsmmsg,"OCBWB @R%d",n);
 #define OR_DSMINFO sprintf(dsmmsg,"OR R%d,R%d",m,n);
 #define ORI_DSMINFO sprintf(dsmmsg,"OR #%d,R0",i);
 #define ORM_DSMINFO sprintf(dsmmsg,"OR.B #%d,@(R0,GBR)",i);
 #define PREF_DSMINFO sprintf(dsmmsg,"PREF");
 #define ROTCL_DSMINFO sprintf(dsmmsg,"ROTCL R%d",n);
 #define ROTCR_DSMINFO sprintf(dsmmsg,"ROTCR R%d",n);
 #define ROTL_DSMINFO sprintf(dsmmsg,"ROTL R%d",n);
 #define ROTR_DSMINFO sprintf(dsmmsg,"ROTR R%d",n);
 #define RTE_DSMINFO sprintf(dsmmsg,"RTE");
 #define RTS_DSMINFO sprintf(dsmmsg,"RTS");
 #define SETS_DSMINFO sprintf(dsmmsg,"SETS");
 #define SETT_DSMINFO sprintf(dsmmsg,"SETT");
 #define SHAD_DSMINFO sprintf(dsmmsg,"SHAD R%d,R%d",m,n);
 #define SHAL_DSMINFO sprintf(dsmmsg,"SHAL R%d",n);
 #define SHAR_DSMINFO sprintf(dsmmsg,"SHAR R%d",n);
 #define SHLD_DSMINFO sprintf(dsmmsg,"SHLD R%d,R%d",m,n);
 #define SHLL_DSMINFO sprintf(dsmmsg,"SHLL R%d");
 #define SHLL2_DSMINFO sprintf(dsmmsg,"SHLL2 R%d",n);
 #define SHLL8_DSMINFO sprintf(dsmmsg,"SHLL8 R%d",n);
 #define SHLL16_DSMINFO sprintf(dsmmsg,"SHLL16 R%d",n);
 #define SHLR_DSMINFO sprintf(dsmmsg,"SHLR R%d",n);
 #define SHLR2_DSMINFO sprintf(dsmmsg,"SHLR2 R%d",n);
 #define SHLR8_DSMINFO sprintf(dsmmsg,"SHLR8 R%d",n);
 #define SHLR16_DSMINFO sprintf(dsmmsg,"SHLR16 R%d",n);
 #define SLEEP_DSMINFO sprintf(dsmmsg,"SLEEP");
 #define STCSR_DSMINFO sprintf(dsmmsg,"STC SR,R%d (P)",n);
 #define STCGBR_DSMINFO sprintf(dsmmsg,"STC GBR,R%d",n);
 #define STCVBR_DSMINFO sprintf(dsmmsg,"STC VBR,R%d (P)",n);
 #define STCSSR_DSMINFO sprintf(dsmmsg,"STC SSR,R%d (P)",n);
 #define STCSPC_DSMINFO sprintf(dsmmsg,"STC SPC,R%d (P)",n);
 #define STCSGR_DSMINFO sprintf(dsmmsg,"STC SGR,R%d (P)",n);
 #define STCDBR_DSMINFO sprintf(dsmmsg,"STC DBR,R%d (P)",n);
 #define STCRm_BANK_DSMINFO sprintf(dsmmsg,"STC R%d_BANK,R%d (P)",m,n);
 #define STCMSR_DSMINFO sprintf(dsmmsg,"STC.L SR,@-R%d (P)",n);
 #define STCMGBR_DSMINFO sprintf(dsmmsg,"STC.L GBR,@R%d",n);
 #define STCMVBR_DSMINFO sprintf(dsmmsg,"STC.L VBR,@-R%d (P)",n);
 #define STCMSSR_DSMINFO sprintf(dsmmsg,"STC.L SSR,@-R%d (P)",n);
 #define STCMSPC_DSMINFO sprintf(dsmmsg,"STC.L SPC,@-R%d (P)",n);
 #define STCMSGR_DSMINFO sprintf(dsmmsg,"STC.L SGR,@-R%d (P)",n);
 #define STCMDBR_DSMINFO sprintf(dsmmsg,"STC.L DBR,@-R%d (P)",n);
 #define STCMRm_BANK_DSMINFO sprintf(dsmmsg,"STC.L R%d_BANK,@-R%d (P)",m,n);
 #define STSMACH_DSMINFO sprintf(dsmmsg,"STS MACH,R%d",n);
 #define STSMACL_DSMINFO sprintf(dsmmsg,"STS MACL,R%d",n);
 #define STSPR_DSMINFO sprintf(dsmmsg,"STS PR,R%d",n);
 #define STSMMACH_DSMINFO sprintf(dsmmsg,"STS.L MACH,@-R%d",n);
 #define STSMMACL_DSMINFO sprintf(dsmmsg,"STS.L MACL,@-R%d",n);
 #define STSMPR_DSMINFO sprintf(dsmmsg,"STS.L PR,@-R%d",n);
 #define STS_DSMINFO sprintf(dsmmsg,"STS FPUL,R%d",n);
 #define STS_SAVE_DSMINFO sprintf(dsmmsg,"STS.L FPUL,@-R%d",n);
 #define STS_FPSCR_DSMINFO sprintf(dsmmsg,"STS FPSCR,R%d",n);
 #define STS_RESTORE_DSMINFO sprintf(dsmmsg,"STS.L FPSCR,@-R%d",n);
 #define SUB_DSMINFO sprintf(dsmmsg,"SUB R%d,R%d",m,n);
 #define SUBC_DSMINFO sprintf(dsmmsg,"SUBC R%d,R%d",m,n);
 #define SUBV_DSMINFO sprintf(dsmmsg,"SUBV R%d,R%d",m,n);
 #define SWAPB_DSMINFO sprintf(dsmmsg,"SWAP.B R%d,R%d",m,n);
 #define SWAPW_DSMINFO sprintf(dsmmsg,"SWAP.W R%d,R%d",m,n);
 #define TAS_DSMINFO sprintf(dsmmsg,"TAS.B @R%d",n);
 #define TRAPA_DSMINFO sprintf(dsmmsg,"TRAPA #%d",i);
 #define TST_DSMINFO sprintf(dsmmsg,"TST R%d,R%d",m,n);
 #define TSTI_DSMINFO sprintf(dsmmsg,"TST #%d,R0",i);
 #define TSTM_DSMINFO sprintf(dsmmsg,"TST.B #%d,@(R0,GBR)",i);
 #define XOR_DSMINFO sprintf(dsmmsg,"XOR R%d,R%d",m,n);
 #define XORI_DSMINFO sprintf(dsmmsg,"XOR #%d,R0",i);
 #define XORM_DSMINFO sprintf(dsmmsg,"XOR.B #%d,@(R0,GBR)",i);
 #define XTRCT_DSMINFO sprintf(dsmmsg,"XTRCT R%d,R%d",m,n);
 #define FABS_DSMINFO sprintf(dsmmsg,"FABS FR%d",n);
 #define FLADD_DSMINFO sprintf(dsmmsg,"FADD FR%d,FR%d",m,n);
 #define FCMP_EQ_DSMINFO sprintf(dsmmsg,"FCMP/EQ  FR%d,FR%d",m,n);
 #define FCMP_GT_DSMINFO sprintf(dsmmsg,"FCMP/GT  FR%d,FR%d",m,n);
 #define FCNVDS_DSMINFO sprintf(dsmmsg,"FCNVDS DR%d,FPUL",m);
 #define FCNVSD_DSMINFO sprintf(dsmmsg,"FCNVSD FPUL,DR%d",n);
 #define FDIV_DSMINFO sprintf(dsmmsg,"FDIV FR%d,FR%d",m,n);
 #define FIPR_DSMINFO sprintf(dsmmsg,"FIPR FV%d,FV%d",m,n);
 #define FLDI0_DSMINFO sprintf(dsmmsg,"FLDI0 FR%d",n);
 #define FLDI1_DSMINFO sprintf(dsmmsg,"FLDI1 FR%d",n);
 #define FLDS_DSMINFO sprintf(dsmmsg,"FLDS FR%d,FPUL",m);
 #define FLOAT_DSMINFO sprintf(dsmmsg,"FLOAT FPUL,FR%d",n);
 #define FMAC_DSMINFO sprintf(dsmmsg,"FMAC FR0,FR%d,FR%d",m,n);
 #define FMUL_DSMINFO sprintf(dsmmsg,"FMUL FR%d,FR%d",m,n);
 #define FNEG_DSMINFO sprintf(dsmmsg,"FNEG FR%d",n);
 #define FSCHG_DSMINFO sprintf(dsmmsg,"FSCHG");
 #define FRCHG_DSMINFO sprintf(dsmmsg,"FRCHG");
 #define FSQRT_DSMINFO sprintf(dsmmsg,"FSQRT FR%d",n);
 #define FSTS_DSMINFO sprintf(dsmmsg,"FSTS FPUL,FR%d",n);
 #define FLSUB_DSMINFO sprintf(dsmmsg,"FSUB FR%d,FR%d",m,n);
 #define FTRC_DSMINFO sprintf(dsmmsg,"FTRC FR%d,FPUL",m);
 #define FTRV_DSMINFO sprintf(dsmmsg,"FTRV FV%d",n);
 #define FMOV_ALL_DSMINFO sprintf(dsmmsg,"FMOV FR[DR XD]%d,FR[DR XD]%d",m,n);
 #define FMOV_ALL_STORE_DSMINFO sprintf(dsmmsg,"FMOV.S FR[DR XD]%d,@R%d",m,n);
 #define FMOV_ALL_LOAD_DSMINFO sprintf(dsmmsg,"FMOV.S @R%d,FR[DR XD]%d",m,n);
 #define FMOV_ALL_RESTORE_DSMINFO sprintf(dsmmsg,"FMOV.S @R%d+,FR[DR XD]%d",m,n);
 #define FMOV_ALL_SAVE_DSMINFO sprintf(dsmmsg,"FMOV.S FR[DR XD]%d,@R%d",m,n);
 #define FMOV_ALL_INDEX_LOAD_DSMINFO sprintf(dsmmsg,"FMOV.S @(R0,R%d),FR[DR XD]%d",m,n);
 #define FMOV_ALL_INDEX_STORE_DSMINFO sprintf(dsmmsg,"FMOV.S FR[DR XD]%d,@(R0,R%d)",m,n);
#endif

  void DSMADD(long m, long n) /* ADD Rm,Rn */
  {
      #ifdef SH4DSM
        ADD_DSMINFO
      #endif
  }
  void DSMADDI(long i, long n)  /* ADD #imm,Rn */
  {
      #ifdef SH4DSM
        ADDI_DSMINFO
      #endif
  }
  void DSMADDC(long m, long n)    /* ADDC Rm,Rn */
  {
      #ifdef SH4DSM
        ADDC_DSMINFO
      #endif
  }
     void DSMADDV(long m, long n)    /* ADDV Rm,Rn */
     {
      #ifdef SH4DSM
        ADDV_DSMINFO
      #endif
      }
  void DSMAND(long m, long n)    /* AND Rm,Rn */
  {
      #ifdef SH4DSM
        AND_DSMINFO
      #endif
  }
  void DSMANDI(long i)    /* AND #imm,R0 */
  {
      #ifdef SH4DSM
        ANDI_DSMINFO
      #endif
 }
  void DSMANDM(long i)    /* AND.B #imm,@(R0,GBR) */
  {
      #ifdef SH4DSM
        ANDM_DSMINFO
      #endif
  }



  void DSMBF(int d)    /* BF disp */
  {
      int disp=d;
      /*
      if ((d&0x80)==0)
              disp=(0x000000FF & d);
      else    disp=(0xFFFFFF00 | d);*/
      #ifdef SH4DSM
        BF_DSMINFO
      #endif
  }

  void DSMBFS(int d)    /* BFS disp */
  {
      int disp=d;
      /*
      if ((d&0x80)==0)
              disp=(0x000000FF & d);
      else    disp=(0xFFFFFF00 | d);*/
      #ifdef SH4DSM
        BFS_DSMINFO
      #endif
  }

  void DSMBRA(int d)    /* BRA disp */
  {
      int disp=d;
      /*
      if ((d&0x800)==0)
             disp=(0x00000FFF & d);
      else   disp=(0xFFFFF000 | d);*/
      #ifdef SH4DSM
        BRA_DSMINFO
      #endif
  }

  void DSMBRAF(int n)   /* BRAF Rn */
  {
      unsigned int temp;
      #ifdef SH4DSM
        BRAF_DSMINFO
      #endif
  }

  void DSMBSR(int d)   /* BSR disp */
  {
      int disp=d;
      /*if ((d&0x800)==0)
           disp=(0x00000FFF & d);
      else disp=(0xFFFFF000 | d);*/
      #ifdef SH4DSM
        BSR_DSMINFO
      #endif
  }

  void DSMBSRF(int n)     /* BSRF Rn */
  {
      unsigned int temp;
      #ifdef SH4DSM
        BSRF_DSMINFO
      #endif
  }

  void DSMBT(int d)    /* BT disp */
  {
      int disp=d;
      /*if ((d&0x80)==0)
           disp=(0x000000FF & d);
      else disp=(0xFFFFFF00 | d);*/
      #ifdef SH4DSM
        BT_DSMINFO
      #endif
 }

 void DSMBTS(int d)    /* BTS disp */
 {
     int disp=d;
     /*if ((d&0x80)==0)
          disp=(0x000000FF & d);
     else disp=(0xFFFFFF00 | d);*/
      #ifdef SH4DSM
        BTS_DSMINFO
      #endif
 }





  void DSMCLRMAC()    /* CLRMAC */
  {
      #ifdef SH4DSM
        CLRMAC_DSMINFO
      #endif
  }

  void DSMCLRS()    /* CLRS */
  {
      #ifdef SH4DSM
        CLRS_DSMINFO
      #endif
  }

  void DSMCLRT()    /* CLRT */
  {
      #ifdef SH4DSM
        CLRT_DSMINFO
      #endif
  }

  void DSMCMPEQ(long m, long n)    /* CMP_EQ Rm,Rn */
  {
      #ifdef SH4DSM
        CMPEQ_DSMINFO
      #endif
  }


  void DSMCMPGE(long m, long n)    /* CMP_GE Rm,Rn */
  {
      #ifdef SH4DSM
        CMPGE_DSMINFO
      #endif
  }

  void DSMCMPGT(long m, long n)    /* CMP_GT Rm,Rn */
  {
      #ifdef SH4DSM
        CMPGT_DSMINFO
      #endif
  }

  void DSMCMPHI(long m, long n)    /* CMP_HI Rm,Rn */
  {
      #ifdef SH4DSM
        CMPHI_DSMINFO
      #endif
  }
void DSMCMPHS(long m, long n)    /* CMP_HS Rm,Rn */
{
      #ifdef SH4DSM
        CMPHS_DSMINFO
      #endif
}
void DSMCMPPL(long n)              /* CMP_PL Rn */
{
      #ifdef SH4DSM
        CMPPL_DSMINFO
      #endif
}
void DSMCMPPZ(long n)    /* CMP_PZ Rn */
{
      #ifdef SH4DSM
        CMPPZ_DSMINFO
      #endif
}

void DSMCMPSTR(long m, long n)    /* CMP_STR Rm,Rn */
{
    unsigned long temp;
      #ifdef SH4DSM
        CMPSTR_DSMINFO
      #endif
}

  void DSMCMPIM(long i)    /* CMP_EQ #imm,R0 */
  {
      #ifdef SH4DSM
        CMPIM_DSMINFO
      #endif
  }

  void DSMDIV0S(long m, long n)    /* DIV0S Rm,Rn */
  {
      #ifdef SH4DSM
        DIV0S_DSMINFO
      #endif
  }
  void DSMDIV0U()        /* DIV0U */
  {
      #ifdef SH4DSM
        DIV0U_DSMINFO
      #endif
  }
  void DSMDIV1(long m, long n)    /* DIV1 Rm,Rn */
  {
      #ifdef SH4DSM
        DIV1_DSMINFO
      #endif
  }

  void DSMDMULS(long m, long n)  /* DMULS.L Rm,Rn */
  {
      #ifdef SH4DSM
        DMULS_DSMINFO
      #endif
  }
  void DSMDMULU(long m, long n)  /* DMULU.L Rm,Rn */
  {
      #ifdef SH4DSM
        DMULU_DSMINFO
      #endif
  }
  void DSMDT(long n)/* DT Rn */
  {
      #ifdef SH4DSM
        DT_DSMINFO
      #endif
  }
  void DSMEXTSB(long m, long n)            /* EXTS.B Rm,Rn */
  {
      #ifdef SH4DSM
        EXTSB_DSMINFO
      #endif
  }
  void DSMEXTSW(long m, long n)            /* EXTS.W Rm,Rn */
  {
      #ifdef SH4DSM
        EXTSW_DSMINFO
      #endif
  }
  void DSMEXTUB(long m, long n)             /* EXTU.B Rm,Rn */
  {
      #ifdef SH4DSM
        EXTUB_DSMINFO
      #endif
  }
  void DSMEXTUW(long m, long n)             /* EXTU.W Rm,Rn */
  {
      #ifdef SH4DSM
        EXTUW_DSMINFO
      #endif
  }
  void DSMJMP(int n)/* JMP @Rn */
  {
      #ifdef SH4DSM
        JMP_DSMINFO
      #endif
  }
  void DSMJSR(int n)/* JSR @Rn */
  {
      #ifdef SH4DSM
        JSR_DSMINFO
      #endif
  }
      void DSMLDCSR(int m)      /* LDC Rm,SR : Privileged */
      {
      #ifdef SH4DSM
        LDCSR_DSMINFO
      #endif
      }
       void DSMLDCGBR(int m)     /* LDC Rm,GBR */
       {
      #ifdef SH4DSM
        LDCGBR_DSMINFO
      #endif
        }
       void DSMLDCVBR(int m)      /* LDC Rm,VBR : Privileged */
       {
      #ifdef SH4DSM
        LDCVBR_DSMINFO
      #endif
        }
       void DSMLDCSSR(int m)      /* LDC Rm,SSR : Privileged */
       {
      #ifdef SH4DSM
        LDCSSR_DSMINFO
      #endif
        }
       void DSMLDCSPC(int m)      /* LDC Rm,SPC : Privileged */
       {
      #ifdef SH4DSM
        LDCSPC_DSMINFO
      #endif
        }
       void DSMLDCDBR(int m)      /* LDC Rm,DBR : Privileged */
       {
      #ifdef SH4DSM
        LDCDBR_DSMINFO
      #endif
        }
       void DSMLDCRn_BANK(int m, int n)  /* LDC Rm,Rn_BANK : Privileged */
       {
      #ifdef SH4DSM
        LDCRn_BANK_DSMINFO
      #endif
        }
       void DSMLDCMSR(int m)     /* LDC.L @Rm+,SR : Privileged */
       {
      #ifdef SH4DSM
        LDCMSR_DSMINFO
      #endif
        }
       void DSMLDCMGBR(int m)     /* LDC.L @Rm+,GBR */
       {
      #ifdef SH4DSM
        LDCMGBR_DSMINFO
      #endif
        }
       void DSMLDCMVBR(int m)     /* LDC.L @Rm+,VBR : Privileged */
       {
      #ifdef SH4DSM
        LDCMVBR_DSMINFO
      #endif
        }
       void DSMLDCMSSR(int m)     /* LDC.L @Rm+,SSR : Privileged */
       {
      #ifdef SH4DSM
        LDCMSSR_DSMINFO
      #endif
        }
       void DSMLDCMSPC(int m)     /* LDC.L @Rm+,SPC : Privileged */
       {
      #ifdef SH4DSM
        LDCMSPC_DSMINFO
      #endif
        }
       void DSMLDCMDBR(int m)     /* LDC.L @Rm+,DBR : Privileged */
       {
      #ifdef SH4DSM
        LDCMDBR_DSMINFO
      #endif
        }
       void DSMLDCMRn_BANK(int m, int n) /* LDC.L @Rm+,Rn_BANK : Privileged ;  n=07 */
       {
      #ifdef SH4DSM
        LDCMRn_BANK_DSMINFO
      #endif
        }
  void DSMLDSFPUL(int m)        /* LDS Rm,FPUL  */
  {
      #ifdef SH4DSM
       LDSFPUL_DSMINFO
      #endif
  }
  void DSMLDSMFPUL(int m)        /* LDS.L @Rm+,FPUL  */
  {
      #ifdef SH4DSM
        LDSMFPUL_DSMINFO
      #endif
  }
  void DSMLDSFPSCR(int  m)        /* LDS Rm,FPSCR  */
  {
      #ifdef SH4DSM
        LDSFPSCR_DSMINFO
      #endif
  }
  void DSMLDSMFPSCR(int  m)        /* LDS.L @Rm+,FPSCR  */
  {
      #ifdef SH4DSM
        LDSMFPSCR_DSMINFO
      #endif
  }
  void DSMLDSMACH(int m)     /* LDS Rm,MACH */
  {
      #ifdef SH4DSM
        LDSMACH_DSMINFO
      #endif
  }
  void DSMLDSMACL(int m)     /* LDS Rm,MACL */
  {
      #ifdef SH4DSM
        LDSMACL_DSMINFO
      #endif
  }
  void DSMLDSPR(int m)      /* LDS Rm,PR */
  {
      #ifdef SH4DSM
        LDSPR_DSMINFO
      #endif
  }
  void DSMLDSMMACH(int m)     /* LDS.L @Rm+,MACH */
  {
      #ifdef SH4DSM
        LDSMMACH_DSMINFO
      #endif
  }
 void DSMLDSMMACL(int m)     /* LDS.L @Rm+,MACL */
 {
      #ifdef SH4DSM
        LDSMMACL_DSMINFO
      #endif
 }
 void DSMLDSMPR(int m)     /* LDS.L @Rm+,PR */
 {
      #ifdef SH4DSM
        LDSMPR_DSMINFO
      #endif
}
 void DSMLDTLB()
 {
      #ifdef SH4DSM
        LDTLB_DSMINFO
      #endif
}
  void DSMMAC_L(long m, long n)   /* MAC.L @Rm+,@Rn+ */
  {
      #ifdef SH4DSM
        MAC_L_DSMINFO
      #endif
}
 void DSMMACW(long m, long n)   /* MAC.W @Rm+,@Rn+ */
 {
      #ifdef SH4DSM
        MACW_DSMINFO
      #endif
}

  void DSMMOV(long m, long n)   /* MOV Rm,Rn */
  {
      #ifdef SH4DSM
        MOV_DSMINFO
      #endif
  }
  void DSMMOVBS(long m, long n) /* MOV.B Rm,@Rn */
  {
      #ifdef SH4DSM
        MOVBS_DSMINFO
      #endif
  }
  void DSMMOVWS(long m, long n) /* MOV.W Rm,@Rn */
  {
      #ifdef SH4DSM
        MOVWS_DSMINFO
      #endif
  }
  void DSMMOVLS(long m, long n) /* MOV.L Rm,@Rn */
  {
      #ifdef SH4DSM
       MOVLS_DSMINFO
      #endif
  }
  void DSMMOVBL(long m, long n) /* MOV.B @Rm,Rn */
  {
      #ifdef SH4DSM
        MOVBL_DSMINFO
      #endif
  }
  void DSMMOVWL(long m, long n) /* MOV.W @Rm,Rn */
  {
      #ifdef SH4DSM
        MOVWL_DSMINFO
      #endif
  }
void DSMMOVLL(long m, long n) /* MOV.L @Rm,Rn */
{
      #ifdef SH4DSM
        MOVLL_DSMINFO
      #endif
}
void DSMMOVBM(long m, long n) /* MOV.B Rm,@-Rn */
{
      #ifdef SH4DSM
        MOVBM_DSMINFO
      #endif
}
void DSMMOVWM(long m, long n) /* MOV.W Rm,@-Rn */
{
      #ifdef SH4DSM
        MOVWM_DSMINFO
      #endif
}
void DSMMOVLM(long m, long n)   /* MOV.L Rm,@-Rn */
{
      #ifdef SH4DSM
        MOVLM_DSMINFO
      #endif
}
void DSMMOVBP(long m, long n) /* MOV.B @Rm+,Rn */
{
      #ifdef SH4DSM
        MOVBP_DSMINFO
      #endif
}
  void DSMMOVWP(long m, long n)    /* MOV.W @Rm+,Rn */
  {
      #ifdef SH4DSM
        MOVWP_DSMINFO
      #endif
  }
  void DSMMOVLP(long m, long n)   /* MOV.L @Rm+,Rn */
  {
      #ifdef SH4DSM
        MOVLP_DSMINFO
      #endif
  }
  void DSMMOVBS0(long m, long n) /* MOV.B Rm,@(R0,Rn) */
  {
      #ifdef SH4DSM
        MOVBS0_DSMINFO
      #endif
  }
  void DSMMOVWS0(long m, long n) /* MOV.W Rm,@(R0,Rn) */
  {
      #ifdef SH4DSM
        MOVWS0_DSMINFO
      #endif
  }
  void DSMMOVLS0(long m, long n) /* MOV.L Rm,@(R0,Rn) */
  {
      #ifdef SH4DSM
        MOVLS0_DSMINFO
      #endif
  }
 void DSMMOVBL0(long m, long n) /* MOV.B @(R0,Rm),Rn */
 {
      #ifdef SH4DSM
        MOVBL0_DSMINFO
      #endif
 }
 void DSMMOVWL0(long m, long n)   /* MOV.W @(R0,Rm),Rn */
 {
      #ifdef SH4DSM
        MOVWL0_DSMINFO
      #endif
 }
 void DSMMOVLL0(long m, long n)   /* MOV.L @(R0,Rm),Rn */
 {
      #ifdef SH4DSM
        MOVLL0_DSMINFO
      #endif
 }
 void DSMMOVI(int i, int n)  /* MOV #imm,Rn */
 {
      #ifdef SH4DSM
        MOVI_DSMINFO
      #endif
 }
  void DSMMOVWI(int d, int n) /* MOV.W @(disp,PC),Rn */
  {
      #ifdef SH4DSM
        MOVWI_DSMINFO
      #endif
  }
 void DSMMOVLI(int d, int n)/* MOV.L @(disp,PC),Rn */
 {
      #ifdef SH4DSM
        MOVLI_DSMINFO
      #endif
 }
  void DSMMOVBLG(int d) /* MOV.B @(disp,GBR),R0 */
  {
      #ifdef SH4DSM
        MOVBLG_DSMINFO
      #endif
  }
  void DSMMOVWLG(int d) /* MOV.W @(disp,GBR),R0 */
  {
      #ifdef SH4DSM
        MOVWLG_DSMINFO
      #endif
  }
  void DSMMOVLLG(int d) /* MOV.L @(disp,GBR),R0 */
  {
      #ifdef SH4DSM
        MOVLLG_DSMINFO
      #endif
  }
  void DSMMOVBSG(int d) /* MOV.B R0,@(disp,GBR) */
  {
      #ifdef SH4DSM
        MOVBSG_DSMINFO
      #endif
  }
 void DSMMOVWSG(int d) /* MOV.W R0,@(disp,GBR) */
 {
      #ifdef SH4DSM
        MOVWSG_DSMINFO
      #endif
 }
 void DSMMOVLSG(int d) /* MOV.L R0,@(disp,GBR) */
 {
      #ifdef SH4DSM
        MOVLSG_DSMINFO
      #endif
 }
 void DSMMOVBS4(long d, long n)   /* MOV.B R0,@(disp,Rn) */
 {
      #ifdef SH4DSM
        MOVBS4_DSMINFO
      #endif
}
 void DSMMOVWS4(long d, long n)  /* MOV.W R0,@(disp,Rn) */
 {
      #ifdef SH4DSM
        MOVWS4_DSMINFO
      #endif
 }
 void DSMMOVLS4(long m, long d, long n) /* MOV.L Rm,@(disp,Rn) */
  {
      #ifdef SH4DSM
        MOVLS4_DSMINFO
      #endif
  }
 void DSMMOVBL4(long m, long d)  /* MOV.B @(disp,Rm),R0 */
 {
      #ifdef SH4DSM
        MOVBL4_DSMINFO
      #endif
 }
  void DSMMOVWL4(long m, long d) /* MOV.W @(disp,Rm),R0 */
  {
      #ifdef SH4DSM
        MOVWL4_DSMINFO
      #endif
  }
  void DSMMOVLL4(long m, long d, long n) /* MOV.L @(disp,Rm),Rn */
  {
      #ifdef SH4DSM
       MOVLL4_DSMINFO
      #endif
  }
  void DSMMOVA(int d)               /* MOVA @(disp,PC),R0 */
  {
      #ifdef SH4DSM
        MOVA_DSMINFO
      #endif
}
void DSMMOVCAL(int n)      //MOVCA.L  R0,@Rn
{
      #ifdef SH4DSM
        MOVCAL_DSMINFO
      #endif
}

  void DSMMOVT(long n)               /* MOVT Rn */
  {
      #ifdef SH4DSM
        MOVT_DSMINFO
      #endif
  }
  void DSMMULL(long m, long n) /* MUL.L Rm,Rn */
  {
      #ifdef SH4DSM
        MULL_DSMINFO
      #endif
}
  void DSMMULS(long m, long n) /* MULS Rm,Rn */
  {
      #ifdef SH4DSM
        MULS_DSMINFO
      #endif
 }
  void DSMMULU(long m, long n) /* MULU Rm,Rn  */
  {
      #ifdef SH4DSM
        MULU_DSMINFO
      #endif
}
  void DSMNEG(long m, long n) /* NEG Rm,Rn */
  {
      #ifdef SH4DSM
        NEG_DSMINFO
      #endif
}
  void DSMNEGC(long m, long n) /* NEGC Rm,Rn */
  {
          unsigned long temp;
      #ifdef SH4DSM
        NEGC_DSMINFO
      #endif
}
  void DSMNOP() /* NOP */
  {
      #ifdef SH4DSM
        NOP_DSMINFO
      #endif
}
  void DSMNOT(long m, long n) /* NOT Rm,Rn */
  {
      #ifdef SH4DSM
        NOT_DSMINFO
      #endif
}
  void DSMOCBI(int n)        /* OCBI @Rn */
  {
      #ifdef SH4DSM
        OCBI_DSMINFO
      #endif
}
  void DSMOCBP(int n)        /* OCBP @Rn */
  {
      #ifdef SH4DSM
        OCBP_DSMINFO
      #endif
}
  void DSMOCBWB(int n)       /* OCBWB @Rn */
  {
      #ifdef SH4DSM
       OCBWB_DSMINFO
      #endif
  }
 void DSMOR(long m, long n) /* OR Rm,Rn */
 {
      #ifdef SH4DSM
        OR_DSMINFO
      #endif
}
 void DSMORI(long i)  /* OR #imm,R0 */
 {
      #ifdef SH4DSM
        ORI_DSMINFO
      #endif
}
 void DSMORM(long i) /* OR.B #imm,@(R0,GBR) */
 {
      #ifdef SH4DSM
        ORM_DSMINFO
      #endif
}
  void DSMPREF(int n) /* PREF */
  {
      #ifdef SH4DSM
       PREF_DSMINFO
      #endif
}
  void DSMROTCL(long n) /* ROTCL Rn */
  {
      #ifdef SH4DSM
        ROTCL_DSMINFO
      #endif
}
  void DSMROTCR(long n) /* ROTCR Rn */
  {
      #ifdef SH4DSM
        ROTCR_DSMINFO
      #endif
}
  void DSMROTL(long n)  /* ROTL Rn */
  {
      #ifdef SH4DSM
        ROTL_DSMINFO
      #endif
}
  void DSMROTR(long n) /* ROTR Rn */
  {
      #ifdef SH4DSM
       ROTR_DSMINFO
      #endif
}
  void DSMRTE() /* RTE */
  {
      #ifdef SH4DSM
        RTE_DSMINFO
      #endif
}
  void DSMRTS() /* RTS */
  {
      #ifdef SH4DSM
        RTS_DSMINFO
      #endif
}
  void DSMSETS() /* SETS */
  {
      #ifdef SH4DSM
        SETS_DSMINFO
      #endif
}
  void DSMSETT()  /* SETT */
  {
      #ifdef SH4DSM
        SETT_DSMINFO
      #endif
}
  void DSMSHAD(int m,int n) /*SHAD Rm,Rn */
  {
      #ifdef SH4DSM
        SHAD_DSMINFO
      #endif
}
  void DSMSHAL(long n) /* SHAL Rn (Same as SHLL) */
  {
      #ifdef SH4DSM
        SHAL_DSMINFO
      #endif
}
  void DSMSHAR(long n) /* SHAR Rn */
  {
      #ifdef SH4DSM
       SHAR_DSMINFO
      #endif
}
  void DSMSHLD(int m,int n)/*SHLD Rm,Rn */
  {
      #ifdef SH4DSM
        SHLD_DSMINFO
      #endif
}
  void DSMSHLL(long n) /* SHLL Rn  (Same as SHAL) */
  {
      #ifdef SH4DSM
       SHLL_DSMINFO
      #endif
}
 void DSMSHLL2(long n) /* SHLL2 Rn */
 {
      #ifdef SH4DSM
       SHLL2_DSMINFO
      #endif
}
 void DSMSHLL8(long n) /* SHLL8 Rn */
 {
      #ifdef SH4DSM
        SHLL8_DSMINFO
      #endif
}
 void DSMSHLL16(long n) /* SHLL16 Rn */
 {
      #ifdef SH4DSM
        SHLL16_DSMINFO
      #endif
}
  void DSMSHLR(long n)   /* SHLR Rn */
  {
      #ifdef SH4DSM
        SHLR_DSMINFO
      #endif
}
  void DSMSHLR2(long n)          /* SHLR2 Rn */
  {
      #ifdef SH4DSM
        SHLR2_DSMINFO
      #endif
}
  void DSMSHLR8(long n)          /* SHLR8 Rn */
  {
      #ifdef SH4DSM
        SHLR8_DSMINFO
      #endif
}
  void DSMSHLR16(long n)         /* SHLR16 Rn */
  {
      #ifdef SH4DSM
        SHLR16_DSMINFO
      #endif
}
  void DSMSLEEP()    /* SLEEP */
  {
      #ifdef SH4DSM
        SLEEP_DSMINFO
      #endif
}
  void DSMSTCSR(int n)      /* STC SR,Rn : Privileged */
       {
      #ifdef SH4DSM
        STCSR_DSMINFO
      #endif
       }
  void DSMSTCGBR(int n)     /* STC GBR,Rn */
       {
      #ifdef SH4DSM
        STCGBR_DSMINFO
      #endif
       }
  void DSMSTCVBR(int n)     /* STC VBR,Rn : Privileged */
       {
      #ifdef SH4DSM
        STCVBR_DSMINFO
      #endif
       }
  void DSMSTCSSR(int n)     /* STC SSR,Rn : Privileged */
       {
      #ifdef SH4DSM
        STCSSR_DSMINFO
      #endif
       }
  void DSMSTCSPC(int n)     /* STC SPC,Rn : Privileged */
       {
      #ifdef SH4DSM
        STCSPC_DSMINFO
      #endif
       }
  void DSMSTCSGR(int n)     /* STC SGR,Rn : Privileged */
       {
      #ifdef SH4DSM
        STCSGR_DSMINFO
      #endif
       }
  void DSMSTCDBR(int n)     /* STC DBR,Rn : Privileged */
       {
      #ifdef SH4DSM
        STCDBR_DSMINFO
      #endif
       }
  void DSMSTCRm_BANK(int n, int m)     /* STC Rm_BANK,Rn : Privileged ; m=07 */
       {
      #ifdef SH4DSM
        STCRm_BANK_DSMINFO
      #endif
       }
  void DSMSTCMSR(int n)     /* STC.L SR,@-Rn : Privileged */
       {
      #ifdef SH4DSM
        STCMSR_DSMINFO
      #endif
       }
  void DSMSTCMGBR(int n)     /* STC.L GBR,@Rn */
       {
      #ifdef SH4DSM
        STCMGBR_DSMINFO
      #endif
       }
  void DSMSTCMVBR(int n)     /* STC.L VBR,@-Rn : Privileged */
       {
      #ifdef SH4DSM
       STCMVBR_DSMINFO
      #endif
       }
  void DSMSTCMSSR(int n)     /* STC.L SSR,@-Rn : Privileged */
       {
      #ifdef SH4DSM
       STCMSSR_DSMINFO
      #endif
       }
  void DSMSTCMSPC(int n)     /* STC.L SPC,@-Rn : Privileged */
       {
      #ifdef SH4DSM
        STCMSPC_DSMINFO
      #endif
       }
  void DSMSTCMSGR(int n)     /* STC.L SGR,@-Rn : Privileged */
     {
      #ifdef SH4DSM
       STCMSGR_DSMINFO
      #endif
     }
  void DSMSTCMDBR(int n)     /* STC.L DBR,@-Rn : Privileged */
     {
      #ifdef SH4DSM
       STCMDBR_DSMINFO
      #endif
     }
  void DSMSTCMRm_BANK(int n, int m)     /* STC.L Rm_BANK,@-Rn : Privileged ; m=07 */
  {
      #ifdef SH4DSM
        STCMRm_BANK_DSMINFO
      #endif
  }
  void DSMSTSMACH(int n)     /* STS MACH,Rn */
  {
      #ifdef SH4DSM
        STSMACH_DSMINFO
      #endif
  }
  void DSMSTSMACL(int n)     /* STS MACL,Rn */
  {
      #ifdef SH4DSM
        STSMACL_DSMINFO
      #endif
  }
  void DSMSTSPR(int n)     /* STS PR,Rn */
  {
      #ifdef SH4DSM
       STSPR_DSMINFO
      #endif
  }
  void DSMSTSMMACH(int n)     /* STS.L MACH,@-Rn */
  {
      #ifdef SH4DSM
        STSMMACH_DSMINFO
      #endif
  }
  void DSMSTSMMACL(int n)     /* STS.L MACL,@-Rn */
  {
      #ifdef SH4DSM
        STSMMACL_DSMINFO
      #endif
  }
  void DSMSTSMPR(int n)     /* STS.L PR,@-Rn */
  {
      #ifdef SH4DSM
        STSMPR_DSMINFO
      #endif
}
  void DSMSTS(int n)           /* STS FPUL,Rn  */
  {
      #ifdef SH4DSM
        STS_DSMINFO
      #endif
  }
  void DSMSTS_SAVE(int n)     /* STS.L FPUL,@-Rn  */
  {
      #ifdef SH4DSM
        STS_SAVE_DSMINFO
      #endif
  }
  void DSMSTS_FPSCR(int n)          /* STS FPSCR,Rn  */
  {
      #ifdef SH4DSM
        STS_FPSCR_DSMINFO
      #endif
  }
  void DSMSTS_RESTORE(int n)  /* STS.L FPSCR,@-Rn  */
  {
      #ifdef SH4DSM
        STS_RESTORE_DSMINFO
      #endif
}
  void DSMSUB(long m, long n) /* SUB Rm,Rn */
  {
      #ifdef SH4DSM
        SUB_DSMINFO
      #endif
}
  void DSMSUBC(long m, long n) /* SUBC Rm,Rn */
  {
      #ifdef SH4DSM
        SUBC_DSMINFO
      #endif
}
  void DSMSUBV(long m, long n) /* SUBV Rm,Rn */
  {
      #ifdef SH4DSM
        SUBV_DSMINFO
      #endif
}
  void DSMSWAPB(long m, long n)      /* SWAP.B Rm,Rn */
  {
      #ifdef SH4DSM
        SWAPB_DSMINFO
      #endif
}
  void DSMSWAPW(long m, long n)      /* SWAP.W Rm,Rn */
  {
      #ifdef SH4DSM
        SWAPW_DSMINFO
      #endif
}
  void DSMTAS(int n) /* TAS.B @Rn */
  {
       int temp;
      #ifdef SH4DSM
        TAS_DSMINFO
      #endif
}
  void DSMTRAPA(int i) /* TRAPA #imm */
  {
      #ifdef SH4DSM
        TRAPA_DSMINFO
      #endif
  }
  void DSMTST(long m, long n) /* TST Rm,Rn */
  {
      #ifdef SH4DSM
       TST_DSMINFO
      #endif
}
  void DSMTSTI(long i) /* TST #imm,R0 */
  {
      #ifdef SH4DSM
        TSTI_DSMINFO
      #endif
}
 void DSMTSTM(long i) /* TST.B #imm,@(R0,GBR) */
 {
      #ifdef SH4DSM
        TSTM_DSMINFO
      #endif
}
  void DSMXOR(long m, long n) /* XOR Rm,Rn */
  {
      #ifdef SH4DSM
        XOR_DSMINFO
      #endif
}
  void DSMXORI(long i)  /* XOR #imm,R0 */
  {
      #ifdef SH4DSM
        XORI_DSMINFO
      #endif
}
  void DSMXORM(long i)  /* XOR.B #imm,@(R0,GBR) */
  {
      #ifdef SH4DSM
        XORM_DSMINFO
      #endif
}
  void DSMXTRCT(long m, long n)     /* XTRCT Rm,Rn */
  {
      #ifdef SH4DSM
        XTRCT_DSMINFO
      #endif
}
void DSMFABS(int n)
{
      #ifdef SH4DSM
        FABS_DSMINFO
      #endif
}
void DSMFLADD(int m,int n)
{
      #ifdef SH4DSM
        FLADD_DSMINFO
      #endif
}
  void DSMFCMP_EQ(int m,int n) /* FCMP/EQ  FRm,FRn */
  {
      #ifdef SH4DSM
        FCMP_EQ_DSMINFO
      #endif
  }
  void DSMFCMP_GT(int m,int n) /* FCMP/GT  FRm,FRn */
  {
      #ifdef SH4DSM
        FCMP_GT_DSMINFO
      #endif
}
     void DSMFCNVDS(int m)
     {
      #ifdef SH4DSM
        FCNVDS_DSMINFO
      #endif
  }
  void DSMFCNVSD(int n)
  {
      #ifdef SH4DSM
        FCNVSD_DSMINFO
      #endif
}
     void DSMFDIV(int m,int n)     /* FDIV FRm,FRn */
     {
      #ifdef SH4DSM
        FDIV_DSMINFO
      #endif
}
  void DSMFIPR(int m,int n)   /* FIPR FVm,FVn */
  {
      #ifdef SH4DSM
        FIPR_DSMINFO
      #endif
  }
     void DSMFLDI0(int n)
     {
      #ifdef SH4DSM
        FLDI0_DSMINFO
      #endif
     }
  void DSMFLDI1(int n)
  {
      #ifdef SH4DSM
        FLDI1_DSMINFO
      #endif
  }
  void DSMFLDS(int m)
  {
      #ifdef SH4DSM
        FLDS_DSMINFO
      #endif
}

    void DSMFLOAT(int n)
    {
      #ifdef SH4DSM
        FLOAT_DSMINFO
      #endif
  }
     void DSMFMAC(int m,int n)
     {
      #ifdef SH4DSM
        FMAC_DSMINFO
      #endif
     }

     void DSMFMUL(int m,int n)
     {
      #ifdef SH4DSM
        FMUL_DSMINFO
      #endif
     }
     void DSMFNEG (int n)
     {
      #ifdef SH4DSM
        FNEG_DSMINFO
      #endif
     }
     void DSMFSCHG()   /* FSCHG */
     {
      #ifdef SH4DSM
        FSCHG_DSMINFO
      #endif
     }
     void DSMFRCHG()   /* FRCHG */
     {
      #ifdef SH4DSM
        FRCHG_DSMINFO
      #endif
     }
    void DSMFSQRT(int n)
    {
      #ifdef SH4DSM
        FSQRT_DSMINFO
      #endif
    }
void DSMFSTS(int n)
{
      #ifdef SH4DSM
        FSTS_DSMINFO
      #endif
}
void DSMFLSUB (int m,int n)
{
      #ifdef SH4DSM
        FLSUB_DSMINFO
      #endif
}
void DSMFTRC(int m)
{
      #ifdef SH4DSM
        FTRC_DSMINFO
      #endif
}
void DSMFTRV (int n)     /* FTRV FVn */
{
      #ifdef SH4DSM
        FTRV_DSMINFO
      #endif
}

void DSMFMOV(int m,int n)
{
#ifdef SH4DSM
 FMOV_ALL_DSMINFO
#endif
}

void DSMFMOV_STORE(int m,int n)
{
#ifdef SH4DSM
 FMOV_ALL_STORE_DSMINFO
#endif
}
void DSMFMOV_LOAD(int m,int n)
{
#ifdef SH4DSM
 FMOV_ALL_LOAD_DSMINFO
#endif
}
void DSMFMOV_RESTORE(int m,int n)
{
#ifdef SH4DSM
 FMOV_ALL_RESTORE_DSMINFO
#endif
}
void DSMFMOV_SAVE(int m,int n)
{
#ifdef SH4DSM
 FMOV_ALL_SAVE_DSMINFO
#endif
}
void DSMFMOV_INDEX_LOAD(int m,int n)
{
#ifdef SH4DSM
 FMOV_ALL_INDEX_LOAD_DSMINFO
#endif
}
void DSMFMOV_INDEX_STORE(int m,int n)
{
#ifdef SH4DSM
 FMOV_ALL_INDEX_STORE_DSMINFO
#endif
}





