/************
Virtu@L Dream, DreamCast emulator for PC
Copyright (C) 2003 eBrain  H.H.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
************/

#include "StdAfx.h"
#include <GL/glut.h>
#include <stdio.h>
#include <stdlib.h>
#include "extern.h"

#ifdef _linux
 #include <unistd.h>
#endif

void reshape(int w, int h)
{
 GLfloat aspect=(GLfloat)w/(GLfloat)h;
 glViewport(0,0,w,h);
 glMatrixMode(GL_PROJECTION);
//glFrustum( -ratio, ratio, -1.0, 1.0, 5.0, 30.0 );
 glOrtho(-6*aspect,6*aspect,-6,6,-6,6);//meme chose que gluPers...?
//gluPerspective(45.0f,(GLfloat)w/(GLfloat)h,0.1f,100.0f);
 glLoadIdentity();
 glMatrixMode(GL_MODELVIEW);
 glutSwapBuffers();
}

void key(unsigned char k, int x, int y)
{
 //if (k==27) exit(0);
}

void InitGL(void)
{
GLfloat ambientlightpos[]= { 0,0,1.5 };
//light
 glLightfv(GL_LIGHT0,GL_AMBIENT, ambientlightpos);
 glEnable(GL_LIGHTING);
 glEnable(GL_LIGHT0);
//sets mode
 glEnable(GL_DEPTH_TEST);
 glEnable(GL_NORMALIZE);
 glDepthFunc(GL_LEQUAL);
 glShadeModel(GL_SMOOTH);
 glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);
 //too much time consumming
 //glHint(GL_PERSPECTIVE_CORRECTION,GL_NICEST);
//clear
 //glClearDepth(1.0);
/*
 glViewport(0,0,WSIZEX,WSIZEY);
 gluPerspective(45.0f,(GLfloat)WSIZEX/(GLfloat)WSIZEY,0.1f,100.0f);
 glMatrixMode(GL_PROJECTION);
 glLoadIdentity();
 glMatrixMode(GL_MODELVIEW);
 glColor3f(0,0,1);
*/
}

void *glstart(void *)
{
 int Window=0;
 glutInitWindowPosition(0,0);
 glutInitWindowSize(WSIZEX,WSIZEY);
 //glutInit(&argc,argv);
 glutInitDisplayMode(GLUT_RGB|GLUT_DOUBLE|GLUT_DEPTH);
 if (!(Window=glutCreateWindow("WYSIWYG")))
 {
  printf("create window err\n");
  exit (1);
 }

/* si 3DFX -> fullscreen
   // Tell Mesa GLX to use 3Dfx driver in fullscreen mode.
   //putenv("MESA_GLX_FX=fullscreen");
   // Disable 3Dfx Glide splash screen
   //putenv("FX_GLIDE_NO_SPLASH=");
*/
 //glutFullScreen();

 InitGL();
 glutDisplayFunc(gtk_main);
 glutReshapeFunc(reshape);
 glutKeyboardFunc(key);
 //glutSpecialFunc();
 //glutVisibilityFunc(visible);
 //glutPassiveMotionFunc( MouseMove );
 //rendernow=1;
/*
 reshape(640,480);
 unsigned long renderw_run;
#if defined _linux
  pthread_create(&renderw_run,NULL,(void *(*)(void *))glutMainLoop,NULL);
#elif defined WINDOWS
  CreateThread(NULL,0,(LPTHREAD_START_ROUTINE)glutMainLoop,NULL,0,&renderw_run);
#endif
*/
 glClear( GL_COLOR_BUFFER_BIT );
 glutMainLoop();
 glutDestroyWindow(Window);
 return NULL;
}

/*
main()
{
 glstart();
}
*/
